#include <stdio.h>
#include <stdlib.h>

typedef struct elem {
	char valeur[11];
	struct elem* suivant;
	}element;
	
typedef element* liste;


void affichage (liste l)
{	
	liste temp;
	int i,j;
	
	temp=l;
	printf("\nVoici votre liste :\n");
	while(temp!=NULL)
	{
		i=0;
        while((temp->valeur[i]=='0')&&(i<strlen(temp->valeur)-1))
        {
            i=i+1;
        }
        for(j=i;j<=strlen(temp->valeur)-1;j++)
        {
            printf("%c",temp->valeur[j]);
        }
        printf("\n");
		temp=temp->suivant;
	}
}



liste ajoutQ (liste l, char e[])
{
	liste nouv;
	liste temp;
	
	nouv=(element*)malloc(sizeof(element));
	nouv->suivant=NULL;
    strcpy(nouv->valeur,e);
	
	temp=l;
	if(l==NULL)
	{
		l=nouv;
	}
	else
	{
		while(temp->suivant!=NULL)
		{
			temp=temp->suivant;
		}
		temp->suivant=nouv;
	}
	return l;
}


int max(liste l)/*trouve le nombre de chifrres que possde le plus long des nombres*/
{
 int x=0;
 liste p;
 p=l;
 while(p!=NULL)
 {
     if(strlen(p->valeur)>x)
     {
         x=strlen(p->valeur);
     }
     p=p->suivant;
 }
 return x;
}


liste modif(liste l, int x)/*modifie la liste l pour que tous les nombres  l'interieur de l aient exactement le mme nombre de chiffres en rajoutant des zros  certain*/
{
 int i;
 char temp[30];
 liste p;
 p=l;
 while(p!=NULL)
 {
     strcpy(temp,"\0");
     if(strlen(p->valeur)<x)
     {
         for(i=1;i<=(x-strlen(p->valeur));i++)
         {
             strcat(temp,"0");
         }
         strcat(temp,p->valeur);
         strcpy(p->valeur,temp);
     }
     p=p->suivant;
 }
 return l;
}



liste acquisition(int *x, int *maxchiffres)
{    
    int i,bon;
	liste l;
	char nb[11],rep;
	
	printf("               TRI A SCEAUX");
	printf("\n\nVous allez entrer une liste de nombre afin de les trier");
	do
    {
        printf("\n\nDans quelle base voulez-vous travailler? \nVotre base doit etre comprise entre 2 et 16 : ");
        scanf("%d",&(*x));
    }
    while(((*x)<2)||((*x)>16));
	l=(element*)malloc(sizeof(element));
	l=NULL;
	do
    {
        do
        {
            bon=1;/*on initialise le booleen  vrai*/
            getchar();
            printf("\nTaper un nombre dans la base %d :",(*x));
            
            gets(nb);
            i=0;
            while((i<strlen(nb))&&(bon==1))
            {
               if((*x<10))
               {
                  if((nb[i]<48)||(nb[i]>(47+(*x))))/*cas o le caractre vis n'est pas compris dans la base choisie*/
                  {
                     bon=0;/*booleen devient faux*/
                  }
               }
               else
               {
                  if(((nb[i]<48)||(nb[i]>(65+(*x)-11)))||((nb[i]>58)&&(nb[i]<65)))
                  {
                     bon=0;
                  }
               }
               i=i+1;
            }
         }
         while(bon==0);
         l=ajoutQ(l,nb);
         do
         {
             printf("Voulez-vous entrer un autre nombre (O/N)");
             scanf("%c",&rep);
         }
         while((rep!='O')&&(rep!='N'));
    }
    while(rep=='O');
    *maxchiffres=max(l);
    l=modif(l,*maxchiffres);
    return l;
    
}






liste tri (liste l, int i, int base)
{
	int j;
	liste sceaux[base];
	liste temp;
	char nombre[11];
	
    for(j=0;j<base;j=j+1)
	{
		sceaux[j]=(element*)malloc(sizeof(element));
		sceaux[j]=NULL;
	}
	while(l!=NULL)
	{
        switch((l->valeur)[i])
		{
			case '0':sceaux[0]=ajoutQ(sceaux[0],l->valeur);
			break;
			case '1':sceaux[1]=ajoutQ(sceaux[1],l->valeur);  
			break;
			case '2':sceaux[2]=ajoutQ(sceaux[2],l->valeur);
			break;
			case '3':sceaux[3]=ajoutQ(sceaux[3],l->valeur);
			break;
			case '4':sceaux[4]=ajoutQ(sceaux[4],l->valeur);
			break;
			case '5':sceaux[5]=ajoutQ(sceaux[5],l->valeur);
			break;
			case '6':sceaux[6]=ajoutQ(sceaux[6],l->valeur);
			break;
			case '7':sceaux[7]=ajoutQ(sceaux[7],l->valeur);
			break;
			case '8':sceaux[8]=ajoutQ(sceaux[8],l->valeur);
			break;
			case '9':sceaux[9]=ajoutQ(sceaux[9],l->valeur);
			break;
			case 'A':sceaux[10]=ajoutQ(sceaux[10],l->valeur);
			break;
			case 'B':sceaux[11]=ajoutQ(sceaux[11],l->valeur);
			break;
			case 'C':sceaux[12]=ajoutQ(sceaux[12],l->valeur);
			break;
			case 'D':sceaux[13]=ajoutQ(sceaux[13],l->valeur);
			break;
			case 'E':sceaux[14]=ajoutQ(sceaux[14],l->valeur);
			break;
			case 'F':sceaux[15]=ajoutQ(sceaux[15],l->valeur);
		}
		temp=l;
		l=l->suivant;
		free(temp);
	}
	for(j=0;j<base;j=j+1)
	{
        while(sceaux[j]!=NULL)
		{
			l=ajoutQ(l,sceaux[j]->valeur);
			temp=sceaux[j];
			sceaux[j]=sceaux[j]->suivant;
			free(temp);
		}
		free(sceaux[j]);
	}
	return l;
}



int main()
{
	int i,maxchiffres,base;
	liste l;
	char nb[30];
	l=(element*)malloc(sizeof(element));
	l=acquisition(&base, &maxchiffres);
    
	for(i=maxchiffres-1;0<=i;i=i-1)
	{
        l=tri(l,i,base);
	}
	affichage(l);
	
	system("PAUSE");	
	return 0;
}
